Imports UJ.ExceptionManagement


Public Class DemoValidation
    Inherits System.Web.UI.Page
    Implements IWebValidationPublisher
 
#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

  End Sub
  Protected WithEvents lnkBackToStart As System.Web.UI.WebControls.HyperLink
  Protected WithEvents lblMessage As System.Web.UI.WebControls.Label
  Protected WithEvents Validator2 As System.Web.UI.WebControls.CustomValidator
  Protected WithEvents txtTestValue2 As System.Web.UI.WebControls.TextBox
  Protected WithEvents Label3 As System.Web.UI.WebControls.Label
  Protected WithEvents Validator1 As System.Web.UI.WebControls.CustomValidator
  Protected WithEvents txtTestValue1 As System.Web.UI.WebControls.TextBox
  Protected WithEvents Label2 As System.Web.UI.WebControls.Label
  Protected WithEvents Label1 As System.Web.UI.WebControls.Label
  Protected WithEvents chkWantStepIn As System.Web.UI.WebControls.CheckBox
  Protected WithEvents Label4 As System.Web.UI.WebControls.Label
  Protected WithEvents Label5 As System.Web.UI.WebControls.Label
  Protected WithEvents Label6 As System.Web.UI.WebControls.Label
  Protected WithEvents Label7 As System.Web.UI.WebControls.Label
  Protected WithEvents btnRunDemo2 As System.Web.UI.WebControls.Button
  Protected WithEvents btnRunDemo1 As System.Web.UI.WebControls.Button
  Protected WithEvents Label8 As System.Web.UI.WebControls.Label
  Protected WithEvents Label9 As System.Web.UI.WebControls.Label
  Protected WithEvents lblMoreErrors As System.Web.UI.WebControls.Label

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
    End Sub

  Private Sub btnRunDemo1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRunDemo1.Click
    If chkWantStepIn.Checked Then Debugger.Break()
    Try
      ValidateInput()
      lblMessage.Text = "No errors found."
    Catch ex As ValidationException
      lblMessage.Text = "Validation errors found."
      WebHelper.DistributeErrors(ex, Me, MatchMode.Name, True)
      lblMoreErrors.Text = ex.GetMessagesAsText()  'Don't forget to retrieve and publish all remaining messages!
    Catch ex As Exception
      Ems.HandleException(Me, ex, Ems.AsParams(sender, e))
    End Try
  End Sub

  Private Sub btnRunDemo2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRunDemo2.Click
    If chkWantStepIn.Checked Then Debugger.Break()
    Try 
      ValidateInput()
      lblMessage.Text = "No errors found."
    Catch _ex As Exception  
      Ems.HandleException(Me, _ex, Ems.AsParams(sender, e))
    End Try
  End Sub

  'Just imagine that this method is buried deep in class hierarchy, so we cannot reach TextBox or Validator
  'directly from validation code. EMS provides a solution - you can deliver and distribute messages in the WebForm.
  Private Sub ValidateInput()
    Try
      Ems.ValidateControl(txtTestValue1.Text.Length >= 4, "txtTestValue1", "TestValue1 must be at least 4 characters long")
      Ems.ValidateControl(txtTestValue2.Text.Length >= 6, "txtTestValue2", "TestValue2 must be at least 6 characters long")
      Ems.Validate(False, FailAction.Buffer,  "Some other error not linked to control or validator.")
      Ems.ThrowBufferedExceptions ("")
    Catch ex As Exception
      Ems.HandleException(Me, ex)
    End Try
  End Sub

  Public Sub PublishValidationException(ByVal exception As UJ.ExceptionManagement.ValidationException) Implements UJ.ExceptionManagement.IWebValidationPublisher.PublishValidationException
    WebHelper.DistributeErrors(exception, Me, MatchMode.Name, True)
    lblMoreErrors.Text = exception.GetMessagesAsText() 'Don't forget to retrieve and publish all remaining messages!
    lblMessage.Text = "Validation errors found. " 
    exception.Published = True 'Let EMS know that validation messages are published.
  End Sub
End Class
