using System;
using System.Drawing;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using UJ.ExceptionManagement;
using UJ.ExceptionManagement.Processing;

namespace UJ.Demos.WebServiceClient {
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class fmMain : System.Windows.Forms.Form
	{
    internal System.Windows.Forms.TabControl tabMain;
    internal System.Windows.Forms.TabPage TabPage3;
    internal System.Windows.Forms.GroupBox GroupBox6;
    internal System.Windows.Forms.TextBox TextBox2;
    internal System.Windows.Forms.Panel Panel1;
    internal System.Windows.Forms.CheckBox chkWantStepIn;
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.ComboBox cboExcAction;
    private System.Windows.Forms.Label label2;
    internal System.Windows.Forms.Button btnCallService;
    private System.Windows.Forms.RadioButton rbServerDebug;
    private System.Windows.Forms.RadioButton rbServerRelease;
    private System.Windows.Forms.Label label4;
    private System.Windows.Forms.RadioButton rbNoWrap;
    private System.Windows.Forms.RadioButton rbWrapInFatal;
    private System.Windows.Forms.RadioButton rbWrapInRemoteSrv;
    private System.Windows.Forms.Label label5;
    private System.Windows.Forms.GroupBox grpClient;
    private System.Windows.Forms.GroupBox grpServer;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public fmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.tabMain = new System.Windows.Forms.TabControl();
      this.TabPage3 = new System.Windows.Forms.TabPage();
      this.grpClient = new System.Windows.Forms.GroupBox();
      this.label5 = new System.Windows.Forms.Label();
      this.rbWrapInRemoteSrv = new System.Windows.Forms.RadioButton();
      this.rbWrapInFatal = new System.Windows.Forms.RadioButton();
      this.rbNoWrap = new System.Windows.Forms.RadioButton();
      this.label4 = new System.Windows.Forms.Label();
      this.grpServer = new System.Windows.Forms.GroupBox();
      this.rbServerRelease = new System.Windows.Forms.RadioButton();
      this.rbServerDebug = new System.Windows.Forms.RadioButton();
      this.label1 = new System.Windows.Forms.Label();
      this.GroupBox6 = new System.Windows.Forms.GroupBox();
      this.label2 = new System.Windows.Forms.Label();
      this.cboExcAction = new System.Windows.Forms.ComboBox();
      this.btnCallService = new System.Windows.Forms.Button();
      this.TextBox2 = new System.Windows.Forms.TextBox();
      this.Panel1 = new System.Windows.Forms.Panel();
      this.chkWantStepIn = new System.Windows.Forms.CheckBox();
      this.tabMain.SuspendLayout();
      this.TabPage3.SuspendLayout();
      this.grpClient.SuspendLayout();
      this.grpServer.SuspendLayout();
      this.GroupBox6.SuspendLayout();
      this.Panel1.SuspendLayout();
      this.SuspendLayout();
      // 
      // tabMain
      // 
      this.tabMain.Controls.Add(this.TabPage3);
      this.tabMain.Dock = System.Windows.Forms.DockStyle.Fill;
      this.tabMain.Location = new System.Drawing.Point(0, 0);
      this.tabMain.Name = "tabMain";
      this.tabMain.SelectedIndex = 0;
      this.tabMain.Size = new System.Drawing.Size(576, 365);
      this.tabMain.TabIndex = 1;
      // 
      // TabPage3
      // 
      this.TabPage3.Controls.Add(this.grpClient);
      this.TabPage3.Controls.Add(this.grpServer);
      this.TabPage3.Controls.Add(this.label1);
      this.TabPage3.Controls.Add(this.GroupBox6);
      this.TabPage3.Location = new System.Drawing.Point(4, 22);
      this.TabPage3.Name = "TabPage3";
      this.TabPage3.Size = new System.Drawing.Size(568, 339);
      this.TabPage3.TabIndex = 2;
      this.TabPage3.Text = "Demo ";
      // 
      // grpClient
      // 
      this.grpClient.Controls.Add(this.label5);
      this.grpClient.Controls.Add(this.rbWrapInRemoteSrv);
      this.grpClient.Controls.Add(this.rbWrapInFatal);
      this.grpClient.Controls.Add(this.rbNoWrap);
      this.grpClient.Controls.Add(this.label4);
      this.grpClient.Dock = System.Windows.Forms.DockStyle.Top;
      this.grpClient.Location = new System.Drawing.Point(0, 152);
      this.grpClient.Name = "grpClient";
      this.grpClient.Size = new System.Drawing.Size(568, 144);
      this.grpClient.TabIndex = 3;
      this.grpClient.TabStop = false;
      this.grpClient.Text = "Client-Side Setting";
      // 
      // label5
      // 
      this.label5.Location = new System.Drawing.Point(80, 104);
      this.label5.Name = "label5";
      this.label5.Size = new System.Drawing.Size(432, 32);
      this.label5.TabIndex = 4;
      this.label5.Text = "RemoteServerException is a subclass of the ValidationException; therefore EMS sho" +
        "ws a message box in this case rather than a full exception report.";
      // 
      // rbWrapInRemoteSrv
      // 
      this.rbWrapInRemoteSrv.Location = new System.Drawing.Point(40, 80);
      this.rbWrapInRemoteSrv.Name = "rbWrapInRemoteSrv";
      this.rbWrapInRemoteSrv.Size = new System.Drawing.Size(440, 24);
      this.rbWrapInRemoteSrv.TabIndex = 3;
      this.rbWrapInRemoteSrv.Text = "Wrap in RemoteServerException (recommended for release build).";
      // 
      // rbWrapInFatal
      // 
      this.rbWrapInFatal.Location = new System.Drawing.Point(40, 56);
      this.rbWrapInFatal.Name = "rbWrapInFatal";
      this.rbWrapInFatal.Size = new System.Drawing.Size(184, 24);
      this.rbWrapInFatal.TabIndex = 2;
      this.rbWrapInFatal.Text = "Wrap in ApplicationException";
      // 
      // rbNoWrap
      // 
      this.rbNoWrap.Checked = true;
      this.rbNoWrap.Location = new System.Drawing.Point(40, 32);
      this.rbNoWrap.Name = "rbNoWrap";
      this.rbNoWrap.Size = new System.Drawing.Size(232, 24);
      this.rbNoWrap.TabIndex = 1;
      this.rbNoWrap.TabStop = true;
      this.rbNoWrap.Text = "No wrap (Default for Debug builds)";
      // 
      // label4
      // 
      this.label4.Location = new System.Drawing.Point(16, 16);
      this.label4.Name = "label4";
      this.label4.Size = new System.Drawing.Size(296, 16);
      this.label4.TabIndex = 0;
      this.label4.Text = "Wrap SoapException representing server error:";
      // 
      // grpServer
      // 
      this.grpServer.Controls.Add(this.rbServerRelease);
      this.grpServer.Controls.Add(this.rbServerDebug);
      this.grpServer.Dock = System.Windows.Forms.DockStyle.Top;
      this.grpServer.Location = new System.Drawing.Point(0, 64);
      this.grpServer.Name = "grpServer";
      this.grpServer.Size = new System.Drawing.Size(568, 88);
      this.grpServer.TabIndex = 2;
      this.grpServer.TabStop = false;
      this.grpServer.Text = "The Service (server-side) settings";
      // 
      // rbServerRelease
      // 
      this.rbServerRelease.Location = new System.Drawing.Point(16, 48);
      this.rbServerRelease.Name = "rbServerRelease";
      this.rbServerRelease.Size = new System.Drawing.Size(256, 32);
      this.rbServerRelease.TabIndex = 7;
      this.rbServerRelease.Text = "Release - server returns a brief error message";
      // 
      // rbServerDebug
      // 
      this.rbServerDebug.Checked = true;
      this.rbServerDebug.Location = new System.Drawing.Point(16, 24);
      this.rbServerDebug.Name = "rbServerDebug";
      this.rbServerDebug.Size = new System.Drawing.Size(304, 24);
      this.rbServerDebug.TabIndex = 6;
      this.rbServerDebug.TabStop = true;
      this.rbServerDebug.Text = "Debug - server returns a detailed exception report";
      // 
      // label1
      // 
      this.label1.Dock = System.Windows.Forms.DockStyle.Bottom;
      this.label1.ForeColor = System.Drawing.Color.Red;
      this.label1.Location = new System.Drawing.Point(0, 307);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(568, 32);
      this.label1.TabIndex = 1;
      this.label1.Text = "Attention: To run this demo set both WebService and WebServiceClient projects as " +
        "statrtup by setting the <Multiple Projects> startup mode in the Solution Propert" +
        "ies Dialog";
      // 
      // GroupBox6
      // 
      this.GroupBox6.Controls.Add(this.label2);
      this.GroupBox6.Controls.Add(this.cboExcAction);
      this.GroupBox6.Controls.Add(this.btnCallService);
      this.GroupBox6.Controls.Add(this.TextBox2);
      this.GroupBox6.Dock = System.Windows.Forms.DockStyle.Top;
      this.GroupBox6.Location = new System.Drawing.Point(0, 0);
      this.GroupBox6.Name = "GroupBox6";
      this.GroupBox6.Size = new System.Drawing.Size(568, 64);
      this.GroupBox6.TabIndex = 0;
      this.GroupBox6.TabStop = false;
      this.GroupBox6.Text = "EMS \"Hello World\" Web Service";
      // 
      // label2
      // 
      this.label2.Location = new System.Drawing.Point(16, 24);
      this.label2.Name = "label2";
      this.label2.Size = new System.Drawing.Size(160, 23);
      this.label2.TabIndex = 4;
      this.label2.Text = "Select the sevice action:";
      // 
      // cboExcAction
      // 
      this.cboExcAction.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
      this.cboExcAction.Items.AddRange(new object[] {
                                                      "0 - Return normally, no exceptions",
                                                      "1 - Emulate client-side fault",
                                                      "2 - Emulate fatal server error"});
      this.cboExcAction.Location = new System.Drawing.Point(184, 24);
      this.cboExcAction.Name = "cboExcAction";
      this.cboExcAction.Size = new System.Drawing.Size(256, 21);
      this.cboExcAction.TabIndex = 3;
      this.cboExcAction.SelectedIndexChanged += new System.EventHandler(this.cboExcAction_SelectedIndexChanged);
      // 
      // btnCallService
      // 
      this.btnCallService.Location = new System.Drawing.Point(448, 24);
      this.btnCallService.Name = "btnCallService";
      this.btnCallService.Size = new System.Drawing.Size(96, 23);
      this.btnCallService.TabIndex = 0;
      this.btnCallService.Text = "Call Service";
      this.btnCallService.Click += new System.EventHandler(this.btnCallService_Click);
      // 
      // TextBox2
      // 
      this.TextBox2.BackColor = System.Drawing.SystemColors.Control;
      this.TextBox2.BorderStyle = System.Windows.Forms.BorderStyle.None;
      this.TextBox2.Dock = System.Windows.Forms.DockStyle.Bottom;
      this.TextBox2.Location = new System.Drawing.Point(3, 53);
      this.TextBox2.Multiline = true;
      this.TextBox2.Name = "TextBox2";
      this.TextBox2.ReadOnly = true;
      this.TextBox2.Size = new System.Drawing.Size(562, 8);
      this.TextBox2.TabIndex = 2;
      this.TextBox2.Text = "";
      // 
      // Panel1
      // 
      this.Panel1.Controls.Add(this.chkWantStepIn);
      this.Panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
      this.Panel1.Location = new System.Drawing.Point(0, 365);
      this.Panel1.Name = "Panel1";
      this.Panel1.Size = new System.Drawing.Size(576, 40);
      this.Panel1.TabIndex = 6;
      // 
      // chkWantStepIn
      // 
      this.chkWantStepIn.Location = new System.Drawing.Point(9, 8);
      this.chkWantStepIn.Name = "chkWantStepIn";
      this.chkWantStepIn.Size = new System.Drawing.Size(192, 24);
      this.chkWantStepIn.TabIndex = 6;
      this.chkWantStepIn.Text = "Check this box to step into code";
      // 
      // fmMain
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(576, 405);
      this.Controls.Add(this.tabMain);
      this.Controls.Add(this.Panel1);
      this.Name = "fmMain";
      this.Text = "EMS Demo Web Service Client";
      this.Load += new System.EventHandler(this.fmMain_Load);
      this.tabMain.ResumeLayout(false);
      this.TabPage3.ResumeLayout(false);
      this.grpClient.ResumeLayout(false);
      this.grpServer.ResumeLayout(false);
      this.GroupBox6.ResumeLayout(false);
      this.Panel1.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 		{
#if DEBUG
      InitHelper.InitializeForWindowsForms(true);
#else
      InitHelper.InitializeForWindowsForms(false);
#endif
      //We remove trace publisher on the client side to let the other trace publisher 
      // on the server side to write its messages to the output window.
      Ems.Settings.ReportPublishers.Remove(typeof(ReportPublisherTrace));
      //we need to increase max chunk size to be able to print server exception reports inside the client-side exception reports
      ReportBuilderText bld = Ems.Settings.ReportBuilders[0] as ReportBuilderText;
      bld.MaxWriteChunkSize = 10000;
      //run the application  
			Application.Run(new fmMain());
		}

    private void fmMain_Load(object sender, System.EventArgs e) {
      cboExcAction.SelectedIndex = 0;
    }

    private void btnCallService_Click(object sender, System.EventArgs e) {
      if (WantStepIn()) Debugger.Break();
      try{
        //Setup - for server error only; for other errors has no effect 
        Ems.Settings.ClientSoapWrapMode = this.GetClientMode(); 
        bool serverDebug = rbServerDebug.Checked;
        //call the service
        EmsDemoWebServiceProxy service = new EmsDemoWebServiceProxy();
        string response = service.HelloWorld(cboExcAction.SelectedIndex, serverDebug);
        MessageBox.Show("Response received: " + response, "Web Service Response");
        
      }//try
      catch(Exception _ex){
        Ems.HandleException(_ex , Ems.AsParams(sender, e));
      }//catch
    }


    private SoapExceptionWrapMode GetClientMode () {
      if (rbNoWrap.Checked)
        return SoapExceptionWrapMode.NoWrap;
      else if (rbWrapInFatal.Checked)
        return SoapExceptionWrapMode.ApplicationException;
      else
        return SoapExceptionWrapMode.RemoteServerException; 
    }

    private bool WantStepIn() {
      return chkWantStepIn.Checked;
    }

    private void cboExcAction_SelectedIndexChanged(object sender, System.EventArgs e) {
      bool vis = (cboExcAction.SelectedIndex == 2);
      grpServer.Visible = vis;
      grpClient.Visible = vis;
    }
	}//class
}//method
